<?php
class cache
{	
	function get($k)
	{
		$file = self::_hash($k);
		if(is_file($file['file'])){
			$v = sreadfile($file['file']);
			if($v === false) return false;
			$temp = unserialize($v);
			return ($temp[0] + filemtime($file['file'])) > $_SERVER['REQUEST_TIME'] ? $temp[1] : false;
		}
		return false;
	}
	function set($k, $v, $time = 2592000)
	{
		$file = self::_hash($k);
		self::createdir($file['dir']);
		return swritefile($file['file'], serialize(array($time , $v)));
	}
	function delete($k)
	{
		$file = self::_hash($k);
		return is_file($file['file']) ? unlink($file['file']) : false;
	}
	function close()
	{
		return true;
	}
	function _hash($k)
	{
		$id = (string)abs(crc32($k));
		$dir = S_ROOT.'./data/block_cache/cache/'. substr($id, 0 , 2)  ;
		return array('dir'=>$dir, 'file'=>$dir . '/' . $id . '.txt');
	}
	function createdir($dir)
    {
		return is_dir($dir) || (self::createdir(dirname($dir)) && mkdir($dir));
    }
}
?>
