<?php
/*
	[UCenter Home] (C) 2007-2008 Comsenz Inc.
	$Id: function_common.php 13235 2009-08-24 09:48:36Z shirui $
*/

if(!defined('IN_UCHOME')) {
	exit('Access Denied');
}

//SQL ADDSLASHES
function saddslashes($string) {
	if(is_array($string)) {
		foreach($string as $key => $val) {
			$string[$key] = saddslashes($val);
		}
	} else {
		$string = addslashes($string);
	}
	return $string;
}

//取消HTML代码
function shtmlspecialchars($string) {
	if(is_array($string)) {
		foreach($string as $key => $val) {
			$string[$key] = shtmlspecialchars($val);
		}
	} else {
		$string = preg_replace('/&amp;((#(\d{3,5}|x[a-fA-F0-9]{4})|[a-zA-Z][a-z0-9]{2,5});)/', '&\\1',
				str_replace(array('&', '"', '<', '>'), array('&amp;', '&quot;', '&lt;', '&gt;'), $string));
	}
	return $string;
}

//字符串解密加密
function authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {
	
	$ckey_length = 4;	// 随机密钥长度 取值 0-32;
	// 加入随机密钥，可以令密文无任何规律，即便是原文和密钥完全相同，加密结果也会每次不同，增大破解难度。
	// 取值越大，密文变动规律越大，密文变化 = 16 的 $ckey_length 次方
	// 当此值为 0 时，则不产生随机密钥
	
	$key = md5($key ? $key : UC_KEY);
	
	$keya = md5(substr($key, 0, 16));
	$keyb = md5(substr($key, 16, 16));
	$keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';
	
	$cryptkey = $keya.md5($keya.$keyc);
	$key_length = strlen($cryptkey);
	
	$string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
	$string_length = strlen($string);
	
	$result = '';
	$box = range(0, 255);
	
	$rndkey = array();
	for($i = 0; $i <= 255; $i++) {
		$rndkey[$i] = ord($cryptkey[$i % $key_length]);
	}
	
	for($j = $i = 0; $i < 256; $i++) {
		$j = ($j + $box[$i] + $rndkey[$i]) % 256;
		$tmp = $box[$i];
		$box[$i] = $box[$j];
		$box[$j] = $tmp;
	}
	
	for($a = $j = $i = 0; $i < $string_length; $i++) {
		$a = ($a + 1) % 256;
		$j = ($j + $box[$a]) % 256;
		$tmp = $box[$a];
		$box[$a] = $box[$j];
		$box[$j] = $tmp;
		$result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
	}
	
	if($operation == 'DECODE') {
		if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
			return substr($result, 26);
		} else {
			return '';
		}
	} else {
		return $keyc.str_replace('=', '', base64_encode($result));
	}
}

//清空cookie
function clearcookie() {
	global $_SGLOBAL;
	obclean();
	ssetcookie('auth', '', -86400 * 365);
	$_SGLOBAL['supe_uid'] = 0;
	$_SGLOBAL['supe_username'] = '';
	$_SGLOBAL['member'] = array();
	
}

//cookie设置
function ssetcookie($var, $value, $life=0) {
	global $_SGLOBAL, $_SC, $_SERVER;
	
	if(setcookie($_SC['cookiepre'].$var, $value, $life?($_SGLOBAL['timestamp']+$life):0, $_SC['cookiepath'], $_SC['cookiedomain'], $_SERVER['SERVER_PORT']==443?1:0)){
	}

}

//数据库连接
function dbconnect() {
	global $_SGLOBAL, $_SC;
	include_once(S_ROOT.'./source/class_mysql.php');
	
	if(empty($_SGLOBAL['db'])) {
		$_SGLOBAL['db'] = new dbstuff;
		$_SGLOBAL['db']->charset = $_SC['dbcharset'];
		$_SGLOBAL['db']->connect($_SC['dbhost'], $_SC['dbuser'], $_SC['dbpw'], $_SC['dbname'], $_SC['pconnect']);
	}
}


//插入管理员信息
function db_insert($username,$password,$email,$salt,$addtime,$is_admin){
global $_SGLOBAL;
include_once(S_ROOT.'./source/class_mysql.php');
$sql="insert into user (uid,username,password,email,salt,addtime,is_admin) values ('','$username','$password','$email','$salt','$addtime','$is_admin')";
$query=$_SGLOBAL['db']->query($sql);

}


//获取在线IP
function getonlineip($format=0) {
	global $_SGLOBAL;
	
	if(empty($_SGLOBAL['onlineip'])) {
		if(getenv('HTTP_CLIENT_IP') && strcasecmp(getenv('HTTP_CLIENT_IP'), 'unknown')) {
			$onlineip = getenv('HTTP_CLIENT_IP');
		} elseif(getenv('HTTP_X_FORWARDED_FOR') && strcasecmp(getenv('HTTP_X_FORWARDED_FOR'), 'unknown')) {
			$onlineip = getenv('HTTP_X_FORWARDED_FOR');
		} elseif(getenv('REMOTE_ADDR') && strcasecmp(getenv('REMOTE_ADDR'), 'unknown')) {
			$onlineip = getenv('REMOTE_ADDR');
		} elseif(isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], 'unknown')) {
			$onlineip = $_SERVER['REMOTE_ADDR'];
		}
		preg_match("/[\d\.]{7,15}/", $onlineip, $onlineipmatches);
		$_SGLOBAL['onlineip'] = $onlineipmatches[0] ? $onlineipmatches[0] : 'unknown';
	}
	if($format) {
		$ips = explode('.', $_SGLOBAL['onlineip']);
		for($i=0;$i<3;$i++) {
			$ips[$i] = intval($ips[$i]);
		}
		return sprintf('%03d%03d%03d', $ips[0], $ips[1], $ips[2]);
	} else {
		return $_SGLOBAL['onlineip'];
	}
}

//判断当前用户登录状态
function checkauth() {
	global $_SGLOBAL, $_SC, $_SCONFIG, $_SCOOKIE, $_SN;
	
	if($_SGLOBAL['mobile'] && $_GET['m_auth']) $_SCOOKIE['auth'] = $_GET['m_auth'];

	if($_SCOOKIE['auth']) {
		//echo $_SCOOKIE['auth'];
		@list($password, $uid) = explode("\t", authcode($_SCOOKIE['auth'], 'DECODE'));
		$_SGLOBAL['supe_uid'] = intval($uid);
		
		if($password && $_SGLOBAL['supe_uid']) {			
			$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('user')." WHERE uid='$_SGLOBAL[supe_uid]'");
			if($member = $_SGLOBAL['db']->fetch_array($query)) {
				if($member['password'] == $password) {
					$_SGLOBAL['supe_username'] = addslashes($member['username']);
					$_SGLOBAL['is_admin'] = $member['is_admin'];
				} else {
					$_SGLOBAL['supe_uid'] = 0;
				}
			} else {
				$_SGLOBAL['supe_uid'] = 0;
			}			
		}
	}
	if(empty($_SGLOBAL['supe_uid'])) {
		clearcookie();
	} else {
		$_SGLOBAL['username'] = $member['username'];
	}
	
}

//获取用户app列表

function getuserapp() {
	global $_SGLOBAL, $_SCONFIG;
	
	$_SGLOBAL['my_userapp'] = $_SGLOBAL['my_menu'] = array();
	$_SGLOBAL['my_menu_more'] = 0;
	
	
	
	if($_SGLOBAL['supe_uid'] && $_SCONFIG['my_status']) {
		$space = getspace($_SGLOBAL['supe_uid']);
		$showcount=0;
		$sql="SELECT up.appid,up.uid,up.privacy,up.allowsidenav,up.allowfeed,up.allowprofilelink,up.narrow,up.displayorder,up.menuorder,mp.appname,mp.smallpic,mp.appurl,mp.status,mp.engname FROM ".tname('userapp')." as up left join ".tname('myapp')." as mp on mp.flag>=0 and  up.appid=mp.appid   WHERE uid='$_SGLOBAL[supe_uid]' ORDER BY menuorder DESC";
		//$sql="SELECT * FROM ".tname('userapp')." WHERE uid='$_SGLOBAL[supe_uid]' ORDER BY menuorder DESC";
		//echo $sql;
		$query = $_SGLOBAL['db']->query($sql, 'SILENT');
		while ($value = $_SGLOBAL['db']->fetch_array($query)) {
			$_SGLOBAL['my_userapp'][$value['appid']] = $value;
			if($value['allowsidenav'] && !isset($_SGLOBAL['userapp'][$value['appid']])) {
				if($space['menunum'] < 5) $space['menunum'] = 10;
				if($space['menunum'] > 100 || $showcount < $space['menunum']) {
					$_SGLOBAL['my_menu'][] = $value;
					$showcount++;
				} else {
					$_SGLOBAL['my_menu_more'] = 1;
				}
			}
		}
		
	}
}


//获取到表名
function tname($name) {
	return $name;
}


//对话框
function showmessage($msgkey, $url_forward='', $second=1, $values=array()) {
	global $_SGLOBAL, $_SC, $_SCONFIG, $_TPL, $space, $_SN;
	
	obclean();
	$catalog=$_SGLOBAL['catalog'];
	//去掉广告
	$_SGLOBAL['ad'] = array();
	
	//语言
	include_once(S_ROOT.'./language/lang_showmessage.php');
	if(isset($_SGLOBAL['msglang'][$msgkey])) {
		$message = lang_replace($_SGLOBAL['msglang'][$msgkey], $values);
	} else {
		$message = $msgkey;
	}
	//手机
	if($_SGLOBAL['mobile']) {
		include template('showmessage');
		exit();
	}
	//显示
	if(empty($_SGLOBAL['inajax']) && $url_forward && empty($second)) {
		header("HTTP/1.1 301 Moved Permanently");
		header("Location: $url_forward");
	} else {
		if($_SGLOBAL['inajax']) {
			if($url_forward) {
				$message = "<a href=\"$url_forward\">$message</a><ajaxok>";
			}
			//$message = "<h1>".$_SGLOBAL['msglang']['box_title']."</h1><a href=\"javascript:;\" onclick=\"hideMenu();\" class=\"float_del\">X</a><div class=\"popupmenu_inner\">$message</div>";
			echo $message;
			ob_out();
		} else {
			if($url_forward) {
				$message = "<a href=\"$url_forward\">$message</a><script>setTimeout(\"window.location.href ='$url_forward';\", ".($second*1000).");</script>";
			}
			include template('showmessage');
		}
	}
	exit();
}

//判断提交是否正确
function submitcheck($var) {
	if(!empty($_POST[$var]) && $_SERVER['REQUEST_METHOD'] == 'POST') {
		if((empty($_SERVER['HTTP_REFERER']) || preg_replace("/https?:\/\/([^\:\/]+).*/i", "\\1", $_SERVER['HTTP_REFERER']) == preg_replace("/([^\:]+).*/", "\\1", $_SERVER['HTTP_HOST'])) && $_POST['formhash'] == formhash()) {
			return true;
		} else {
			//echo $_SERVER['HTTP_REFERER'];
			if(strstr($_SERVER['HTTP_REFERER'],"zhinei.com"))
			{				
				return true;
			}
			else
			{
				showmessage('submit_invalid');
			}
		}
	} else {
		return false;
	}
}

//添加数据
function inserttable($tablename, $insertsqlarr, $returnid=0, $replace = false, $silent=0) {
	global $_SGLOBAL;
	
	$insertkeysql = $insertvaluesql = $comma = '';
	foreach ($insertsqlarr as $insert_key => $insert_value) {
		$insertkeysql .= $comma.'`'.$insert_key.'`';
		$insert_value=str_replace("'","\'",$insert_value);
		$insertvaluesql .= $comma.'\''.$insert_value.'\'';
		$comma = ', ';
	}
	$method = $replace?'REPLACE':'INSERT';
	$_SGLOBAL['db']->query($method.' INTO '.tname($tablename).' ('.$insertkeysql.') VALUES ('.$insertvaluesql.')', $silent?'SILENT':'');
	if( $_SGLOBAL['db']->insert_id()){
		if($returnid && !$replace) {
			return $_SGLOBAL['db']->insert_id();
		}else
	 		return true;
	}else
		 return false;
}

//更新数据
function updatetable($tablename, $setsqlarr, $wheresqlarr, $silent=0) {
	global $_SGLOBAL;
	
	$setsql = $comma = '';
	foreach ($setsqlarr as $set_key => $set_value) {
		if(is_array($set_value)) {
		//$set_value[0]=str_replace("'","\'",$set_value[0]);
		//$set_value[0]=stripslashes($set_value[0]);
			$setsql .= $comma.'`'.$set_key.'`'.'='.$set_value[0];
			
		} else {
		//$set_value=str_replace("'","\'",$set_value);
		//$set_value=stripslashes($set_value);
			$setsql .= $comma.'`'.$set_key.'`'.'=\''.$set_value.'\'';
		}
		$comma = ', ';
	}
	$where = $comma = '';
	if(empty($wheresqlarr)) {
		$where = '1';
	} elseif(is_array($wheresqlarr)) {
		foreach ($wheresqlarr as $key => $value) {
			$where .= $comma.'`'.$key.'`'.'=\''.$value.'\'';
			$comma = ' AND ';
		}
	} else {
		$where = $wheresqlarr;
	}
	return $_SGLOBAL['db']->query('UPDATE '.tname($tablename).' SET '.$setsql.' WHERE '.$where, $silent?'SILENT':'');
}


//检查权限
//function checkperm($permtype) {
//	global $_SGLOBAL, $space;
//	
//	if($permtype == 'admin') $permtype = 'manageconfig';
//	
//	$var = 'checkperm_'.$permtype;
//	if(!isset($_SGLOBAL[$var])) {
//		if(empty($_SGLOBAL['supe_uid'])) {
//			$_SGLOBAL[$var] = '';
//		} else {
//			if(empty($_SGLOBAL['member'])) getmember();
//			$gid = getgroupid($_SGLOBAL['member']['experience'], $_SGLOBAL['member']['groupid']);
//			@include_once(S_ROOT.'./data/data_usergroup_'.$gid.'.php');
//			
//			if($gid != $_SGLOBAL['member']['groupid']) {
//				updatetable('space', array('groupid'=>$gid), array('uid'=>$_SGLOBAL['supe_uid']));
//				//赠送道具
//				if($_SGLOBAL['usergroup'][$gid]['magicaward']) {
//					include_once(S_ROOT.'./source/inc_magicaward.php');
//				}
//			}
//			
//			$_SGLOBAL[$var] = empty($_SGLOBAL['usergroup'][$gid][$permtype])?'':$_SGLOBAL['usergroup'][$gid][$permtype];
//			if(substr($permtype, 0, 6) == 'manage' && empty($_SGLOBAL[$var])) {
//				$_SGLOBAL[$var] = $_SGLOBAL['usergroup'][$gid]['manageconfig'];//权限覆盖
//				if(empty($_SGLOBAL[$var])) {
//					$_SGLOBAL[$var] = ckfounder($_SGLOBAL['supe_uid'])?1:0;//创始人
//				}
//			}
//		}
//	}
//	return $_SGLOBAL[$var];
//}

//写运行日志
function runlog($file, $log, $halt=0) {
	global $_SGLOBAL, $_SERVER;
	
	$nowurl = $_SERVER['REQUEST_URI']?$_SERVER['REQUEST_URI']:($_SERVER['PHP_SELF']?$_SERVER['PHP_SELF']:$_SERVER['SCRIPT_NAME']);
	$log = sgmdate('Y-m-d H:i:s', $_SGLOBAL['timestamp'])."\t$type\t".getonlineip()."\t$_SGLOBAL[supe_uid]\t{$nowurl}\t".str_replace(array("\r", "\n"), array(' ', ' '), trim($log))."\n";
	$yearmonth = sgmdate('Ym', $_SGLOBAL['timestamp']);
	$logdir = './data/log/';
	if(!is_dir($logdir)) mkdir($logdir, 0777);
	$logfile = $logdir.$yearmonth.'_'.$file.'.php';
	if(@filesize($logfile) > 2048000) {
		$dir = opendir($logdir);
		$length = strlen($file);
		$maxid = $id = 0;
		while($entry = readdir($dir)) {
			if(strexists($entry, $yearmonth.'_'.$file)) {
				$id = intval(substr($entry, $length + 8, -4));
				$id > $maxid && $maxid = $id;
			}
		}
		closedir($dir);
		$logfilebak = $logdir.$yearmonth.'_'.$file.'_'.($maxid + 1).'.php';
		@rename($logfile, $logfilebak);
	}
	if($fp = @fopen($logfile, 'a')) {
		@flock($fp, 2);
		fwrite($fp, "<?PHP exit;?>\t".str_replace(array('<?', '?>', "\r", "\n"), '', $log)."\n");
		fclose($fp);
	}
	if($halt) exit();
}

//获取字符串
function getstr($string, $length, $in_slashes=0, $out_slashes=0, $censor=0, $bbcode=0, $html=0) {
	global $_SC, $_SGLOBAL,$_SCONFIG;
	
	$string = trim($string);
	
	if($in_slashes) {
		//传入的字符有slashes
		$string = sstripslashes($string);
	}
	if($html < 0) {
		//去掉html标签
		$string = preg_replace("/(\<[^\<]*\>|\r|\n|\s|\[.+?\])/is", ' ', $string);
		$string = shtmlspecialchars($string);
	} elseif ($html == 0) {
		//转换html标签
		$string = shtmlspecialchars($string);
	}
	if($censor) {
		//词语屏蔽
		if($_SC['isSAE']){
			if($_SCONFIG['ismemcache'] && $_SGLOBAL['mc'])
			$_SGLOBAL['censor']=memcache_get($_SGLOBAL['mc'],"_SGLOBAL['censor']");
		}else{
			@include_once(S_ROOT.'./data/data_censor.php');
		}
		if($_SGLOBAL['censor']['banned'] && preg_match($_SGLOBAL['censor']['banned'], $string)) {
			showmessage('information_contains_the_shielding_text');
		} else {
			$string = empty($_SGLOBAL['censor']['filter']) ? $string :
				@preg_replace($_SGLOBAL['censor']['filter']['find'], $_SGLOBAL['censor']['filter']['replace'], $string);
		}
	}
	if($length && strlen($string) > $length) {
		//截断字符
		$wordscut = '';
		if(strtolower($_SC['charset']) == 'utf-8') {
			//utf8编码
			$n = 0;
			$tn = 0;
			$noc = 0;
			while ($n < strlen($string)) {
				$t = ord($string[$n]);
				if($t == 9 || $t == 10 || (32 <= $t && $t <= 126)) {
					$tn = 1;
					$n++;
					$noc++;
				} elseif(194 <= $t && $t <= 223) {
					$tn = 2;
					$n += 2;
					$noc += 2;
				} elseif(224 <= $t && $t < 239) {
					$tn = 3;
					$n += 3;
					$noc += 2;
				} elseif(240 <= $t && $t <= 247) {
					$tn = 4;
					$n += 4;
					$noc += 2;
				} elseif(248 <= $t && $t <= 251) {
					$tn = 5;
					$n += 5;
					$noc += 2;
				} elseif($t == 252 || $t == 253) {
					$tn = 6;
					$n += 6;
					$noc += 2;
				} else {
					$n++;
				}
				if ($noc >= $length) {
					break;
				}
			}
			if ($noc > $length) {
				$n -= $tn;
			}
			$wordscut = substr($string, 0, $n);
		} else {
			for($i = 0; $i < $length - 1; $i++) {
				if(ord($string[$i]) > 127) {
					$wordscut .= $string[$i].$string[$i + 1];
					$i++;
				} else {
					$wordscut .= $string[$i];
				}
			}
		}
		$string = $wordscut;
	}
	if($bbcode) {
		include_once(S_ROOT.'./source/function_bbcode.php');
		$string = bbcode($string, $bbcode);
	}
	if($out_slashes) {
		$string = saddslashes($string);
	}
	return trim($string);
}


/**
 * 获取字符串 判断当内容被屏蔽时不进行提示返回0
 *
 * @param mixed $string This is a description
 * @param mixed $length This is a description
 * @param mixed $in_slashes This is a description
 * @param mixed $out_slashes This is a description
 * @param mixed $censor This is a description
 * @param mixed $bbcode This is a description
 * @param mixed $html This is a description
 * @return mixed This is the return value description
 *
 */
function getstr_iscensor($string) {
	global $_SC, $_SGLOBAL,$_SCONFIG;
	
	$string = trim($string);
	if($_SC['isSAE']){
	if($_SCONFIG['ismemcache'] && $_SGLOBAL['mc'])
		$_SGLOBAL['censor']=memcache_get($_SGLOBAL['mc'],"_SGLOBAL['censor']");
	}else{
		@include_once(S_ROOT.'./data/data_censor.php');
	}
	if($_SGLOBAL['censor']['banned'] && preg_match($_SGLOBAL['censor']['banned'], $string)) {
		return 0;
		//showmessage('information_contains_the_shielding_text');
	} else {
		$string = empty($_SGLOBAL['censor']['filter']) ? $string :
			@preg_replace($_SGLOBAL['censor']['filter']['find'], $_SGLOBAL['censor']['filter']['replace'], $string);
	}
	return 1;
}


//时间格式化
function sgmdate($dateformat, $timestamp='', $format=0) {
	global $_SCONFIG, $_SGLOBAL;
	if(empty($timestamp)) {
		$timestamp = $_SGLOBAL['timestamp'];
	}
	$timeoffset = strlen($_SGLOBAL['member']['timeoffset'])>0?intval($_SGLOBAL['member']['timeoffset']):intval($_SCONFIG['timeoffset']);
	$result = '';
	if($format) {
		$time = $_SGLOBAL['timestamp'] - $timestamp;
		if($time > 24*3600) {
			$result = gmdate($dateformat, $timestamp + $timeoffset * 3600);
		} elseif ($time > 3600) {
			$result = intval($time/3600).lang('hour').lang('before');
		} elseif ($time > 60) {
			$result = intval($time/60).lang('minute').lang('before');
		} elseif ($time > 0) {
			$result = $time.lang('second').lang('before');
		} else {
			$result = lang('now');
		}
	} else {
		$result = gmdate($dateformat, $timestamp + $timeoffset * 3600);
	}
	return $result;
}

//字符串时间化
function sstrtotime($string) {
	global $_SGLOBAL, $_SCONFIG;
	$time = '';
	if($string) {
		$time = strtotime($string);
		if(gmdate('H:i', $_SGLOBAL['timestamp'] + $_SCONFIG['timeoffset'] * 3600) != date('H:i', $_SGLOBAL['timestamp'])) {
			$time = $time - $_SCONFIG['timeoffset'] * 3600;
		}
	}
	return $time;
}

//分页
function multi($num, $perpage, $curpage, $mpurl, $ajaxdiv='', $todiv='') {  //总数，每页显示数，显示多少页，显示地址
	global $_SCONFIG, $_SGLOBAL;
	
	if(empty($ajaxdiv) && $_SGLOBAL['inajax']) {
		$ajaxdiv = $_GET['ajaxdiv'];
	}
	
	$page =10;
	if($_SGLOBAL['showpage']) $page = $_SGLOBAL['showpage'];
	
	$multipage = '';
	$mpurl .= strpos($mpurl, '?') ? '&' : '?';
	$realpages = 1;
	if($num > $perpage) {
		$offset = 2;
		$realpages = @ceil($num / $perpage);
		$pages = $_SCONFIG['maxpage'] && $_SCONFIG['maxpage'] < $realpages ? $_SCONFIG['maxpage'] : $realpages;
		if($page > $pages) {
			$from = 1;
			$to = $pages;
		} else {
			$from = $curpage - $offset;
			$to = $from + $page - 1;
			if($from < 1) {
				$to = $curpage + 1 - $from;
				$from = 1;
				if($to - $from < $page) {
					$to = $page;
				}
			} elseif($to > $pages) {
				$from = $pages - $page + 1;
				$to = $pages;
			}
		}
		$multipage = '';
		$urlplus = $todiv?"#$todiv":'';
		if($curpage - $offset > 1 && $pages > $page) {
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=1&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=1{$urlplus}\"";
			}
			$multipage .= " class=\"first\">1 ...</a>";
		}
		if($curpage > 1) {
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=".($curpage-1)."&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=".($curpage-1)."$urlplus\"";
			}
			$multipage .= " class=\"prev\">&lsaquo;&lsaquo;</a>";
		}
		for($i = $from; $i <= $to; $i++) {
			if($i == $curpage) {
				$multipage .= '<strong>'.$i.'</strong>';
			} else {
				$multipage .= "<a ";
				if($_SGLOBAL['inajax']) {
					$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=$i&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
				} else {
					$multipage .= "href=\"{$mpurl}page=$i{$urlplus}\"";
				}
				$multipage .= ">$i</a>";
			}
		}
		if($curpage < $pages) {
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=".($curpage+1)."&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=".($curpage+1)."{$urlplus}\"";
			}
			$multipage .= " class=\"next\">&rsaquo;&rsaquo;</a>";
		}
		if($to < $pages) {
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=$pages&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=$pages{$urlplus}\"";
			}
			$multipage .= " class=\"last\">... $realpages</a>";
		}
		if($multipage) {
			$multipage = '<em>&nbsp;'.$num.'&nbsp;</em>'.$multipage;
		}
	}
	return $multipage;
}


//处理分页
function smulti($start, $perpage, $count, $url, $ajaxdiv='') {
	global $_SGLOBAL;
	
	$multi = array('last'=>-1, 'next'=>-1, 'begin'=>-1, 'end'=>-1, 'html'=>'');
	if($start > 0) {
		if(empty($count)) {
			showmessage('no_data_pages');
		} else {
			$multi['last'] = $start - $perpage;
		}
	}
	
	$showhtml = 0;
	if($count == $perpage) {
		$multi['next'] = $start + $perpage;
	}
	$multi['begin'] = $start + 1;
	$multi['end'] = $start + $count;
	
	if($multi['begin'] >= 0) {
		if($multi['last'] >= 0) {
			$showhtml = 1;
			if($_SGLOBAL['inajax']) {
				$multi['html'] .= "<a href=\"javascript:;\" onclick=\"ajaxget('$url&ajaxdiv=$ajaxdiv', '$ajaxdiv')\">|&lt;</a> <a href=\"javascript:;\" onclick=\"ajaxget('$url&start=$multi[last]&ajaxdiv=$ajaxdiv', '$ajaxdiv')\">&lt;</a> ";
			} else {
				$multi['html'] .= "<a href=\"$url\">|&lt;</a> <a href=\"$url&start=$multi[last]\">&lt;</a> ";
			}
		} else {
			//$multi['html'] .= "<span>&lt;</span>";
		}
		$multi['html'] .= "<em class=\"otherpage\"> $multi[begin]~$multi[end] </em>";
		if($multi['next'] >= 0) {
			$showhtml = 1;
			if($_SGLOBAL['inajax']) {
				$multi['html'] .= " <a href=\"javascript:;\" onclick=\"ajaxget('$url&start=$multi[next]&ajaxdiv=$ajaxdiv', '$ajaxdiv')\">&gt;</a> ";
			} else {
				$multi['html'] .= " <a href=\"$url&start=$multi[next]\">&gt;</a>";
			}
		} else {
			//$multi['html'] .= " &gt;";
		}
	}
	
	return $showhtml?$multi['html']:'';
}

//ob
function obclean() {
	global $_SC;
	
	ob_end_clean();
	if ($_SC['gzipcompress'] && function_exists('ob_gzhandler')) {
		ob_start('ob_gzhandler');
	} else {
		ob_start();
	}
}


//模板调用

function template($name) {
	global $_SCONFIG, $_SGLOBAL,$_SC;
	if(strexists($name,'/')) {
		$tpl = $name;
	} else {
		$tpl = "template/$_SCONFIG[template]/$name";
	}
	if($_SC['isSAE'])
	{

		if($_SC['isdev'])
		{			
			//更新所有的缓存
			if($_SCONFIG['ismemcache'] && $_SGLOBAL['mc'])
			memcache_delete($_SGLOBAL['mc'],$tpl);
		}	
		
		template_storage($name);	

		$objfile= 'saemc://'.$tpl  ;

	}else
	{
		
		$objfile = S_ROOT.'./data/tpl_cache/'.str_replace('/','_',$tpl).'.php';
		if(!file_exists($objfile)) {
			include_once(S_ROOT.'./source/function_template.php');
			parse_template($tpl);
		}
	}
	return $objfile;
}


function template_storage($name) {
	global $_SCONFIG, $_SGLOBAL,$_SC;	
	
	if(strexists($name,'/')) {
		$tpl = $name;
	} else {
		$tpl = "template/$_SCONFIG[template]/$name";
	}
	
	$objfile = S_ROOT.'./data/tpl_cache/'.str_replace('/','_',$tpl).'.php';

	$domain="";
	if($_SCONFIG['ismemcache'] && $_SGLOBAL['mc'])
	$templatemmc=	memcache_get($_SGLOBAL['mc'],$tpl);

	if(empty($templatemmc)) {

		include_once(S_ROOT.'./source/function_template.php');
		
		$templatemmc=parse_template($tpl);
		
	}
	
	
}

//子模板更新检查
function subtplcheck($subfiles, $mktime, $tpl) {
	global $_SC, $_SCONFIG;
	
	if($_SC['tplrefresh'] && ($_SC['tplrefresh'] == 1 || mt_rand(1, $_SC['tplrefresh']) == 1)) {
		$subfiles = explode('|', $subfiles);
		foreach ($subfiles as $subfile) {
			$tplfile = S_ROOT.'./'.$subfile.'.htm';
			if(!file_exists($tplfile)) {
				$tplfile = str_replace('/'.$_SCONFIG['template'].'/', '/default/', $tplfile);
			}
			@$submktime = filemtime($tplfile);
			if($submktime > $mktime) {
				include_once(S_ROOT.'./source/function_template.php');
				parse_template($tpl);
				break;
			}
		}
	}
}

//模块
function block($param) {
	global $_SBLOCK;
	
	include_once(S_ROOT.'./source/function_block.php');
	block_batch($param);
}

//获取数目
function getcount($tablename, $wherearr=array(), $get='COUNT(*)') {
	global $_SGLOBAL;
	if(empty($wherearr)) {
		$wheresql = '1';
	} else {
		$wheresql = $mod = '';
		foreach ($wherearr as $key => $value) {
			$wheresql .= $mod."`$key`='$value'";
			$mod = ' AND ';
		}
	}
	return $_SGLOBAL['db']->result($_SGLOBAL['db']->query("SELECT $get FROM ".tname($tablename)." WHERE $wheresql LIMIT 1"), 0);
}

//调整输出
function ob_out() {
	global $_SGLOBAL, $_SCONFIG, $_SC;
	
	$content = ob_get_contents();
	
	$preg_searchs = $preg_replaces = $str_searchs = $str_replaces = array();
	if($_SCONFIG['allowrewrite']) {
		
		//index搜索
		$preg_searchs[] = "/\<a href\=\"(index).php\?ac=(search)&keyword=(([a-zA-Z0-9\=\(\)\_\（\）\.]|[\x80-\xff])+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\3/\',\'index_\\5\')';
		$preg_searchs[] = "/\<a href\=\"(index).php\?ac=(search)&keyword=(.*)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\',\'\\3\')';
		
		
		$preg_searchs[] = "/\<a href\=\"(android|apple).php\?ac=(down)&id=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'\\3\')';
		
		$preg_searchs[] = "/\<a href\=\"(android|apple).php\?ac=(down)&id=([0-9]+?)&k=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'\\3_\\4\')';
		
		
		
		//index所有
		$preg_searchs[] = "/\<a href\=\"(index).php\?ac=(alllist)&op=(newsoft|newgame|recomgame|recomsoft)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\3/\',\'index_\\4\')';
		$preg_searchs[] = "/\<a href\=\"(index).php\?ac=(alllist)&op=(newsoft|newgame|recomgame|recomsoft)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\',\'\\3\')';
		
		//index联系我们
		$preg_searchs[] = "/\<a href\=\"(index).php\?ac=(contact)&op=(copyright)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\',\'\\3\')';
		$preg_searchs[] = "/\<a href\=\"(index).php\?ac=(contact)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2\',\'\')';
		
		//android
		//android搜索
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(search)&keyword=(([a-zA-Z0-9\=\(\)\_\（\）\.]|[\x80-\xff])+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\\3/\',\'index_\\5\')';
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(search)&keyword=(.*)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\2/\',\'\\3\')';
		//android详细页面
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(detail)&cname=([a-zA-Z0-9]+?)&id=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\3/\',\'\\4\')';
		
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(detail)&cname=([a-zA-Z0-9]+?)&id=([0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\3/\',\'\\4_p\\5\')';
		//android分类分页页面
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\4/\',\'\\5_\\6\')';
		//android分类页面
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\4/\',\'\\5\')';
		
		//android分类页面首页
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\4/\',\'index_\\5\')';
		
		//android分类页面首页
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\',\'\\4\')';
		
		
		//android游戏软件列表排序分页
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\3/list/\',\'\\4_\\5\')';
		
		//android游戏软件列表排序
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\3/list/\',\'\\4\')';
		
		
		//android游戏软件列表分页
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\3/list/\',\'index_\\4\')';
		
		
		//android游戏软件列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(applists)&lx=(game|soft)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\3/\',\'list\')';
		
		//android游戏软件封面
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(game|soft)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\',\'\\2\')';
		
		
		//android推荐分页
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\4/\',\'\\5_\\6\')';
		

		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\\4/\',\'\\5\')';
		
		
		//android推荐分页
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\4/\',\'index_\\5\')';
		

		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\2/\',\'\\4\')';


//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&typelx=(game|soft)&orderby=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\\3/\',\'\\4_\\5\')';
		
		
		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&typelx=(game|soft)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\\3/\',\'\\4\')';


		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&typelx=(game|soft)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\\3/\',\'index_\\4\')';
		
		
		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&typelx=(game|soft)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\2/\',\'\\3\')';
		
		
		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'\\3_\\4\')';
		
		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'\\3\')';
		
		
		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'index_\\3\')';
		
		//android推荐
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(recommend)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\',\'\\2\')';
		

		
		
		
		
		
		//apple
		
		
		//apple搜索
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(search)&type=(iphone|ipad)&keyword=(([a-zA-Z0-9\=\(\)\_\（\）\.]|[\x80-\xff])+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\3/\',\'index_\\5\')';
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(search)&type=(iphone|ipad)&keyword=(.*)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\1/\',\'\\3\')';
		//apple详细页面
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(detail)&type=(iphone|ipad)&cname=([a-zA-Z0-9]+?)&id=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\3/\',\'\\4\')';
		
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(detail)&type=(iphone|ipad)&cname=([a-zA-Z0-9]+?)&id=([0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\3/\',\'\\4_p\\5\')';
		//apple分类页面
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\4/\',\'\\5_\\6\')';
		
		//apple分类页面
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\4/\',\'\\5\')';
		
		//apple分类页面首页
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\4/\',\'index_\\5\')';
		
		//apple分类页面首页
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)&cname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\',\'\\4\')';
		
		
		//apple游戏软件列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\3/list/\',\'\\4_\\5\')';
		
		//apple游戏软件列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\3/list/\',\'\\4\')';
		
		
		//apple游戏软件列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\3/list/\',\'index_\\4\')';
		
		
		//apple游戏软件列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(applists)&type=(iphone|ipad)&lx=(game|soft)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\3/\',\'list\')';
		
		//apple游戏软件封面
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(game|soft)&type=(iphone|ipad)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\',\'\\1\')';
		
		
		//apple推荐分页
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\4/\',\'\\5_\\6\')';
		

		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\4/\',\'\\5\')';
		
		
		
		
		//apple推荐分页
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\4/\',\'index_\\5\')';
		

		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&cname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\1/\',\'\\4\')';












//android专辑列表分页
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(subject)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'index_\\3\')';
		
		//android专辑列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(subject)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\',\'\\2\')';
		//android专辑详细列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(subdetail)&subjectid=([0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\\3/\',\'index_\\4\')';
		
		//android专辑详细列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(subdetail)&subjectid=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\2/\',\'\\3\')';
		
		//apple专辑列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(subdetail)&sname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\2/\\3/\',\'index_\\4\')';
		
		//apple专辑列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(subdetail)&sname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\2/\',\'\\3\')';
		
		//android资讯分类分页列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(news)&cname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\\3/\',\'index_\\4\')';
		
		//android资讯分类列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(news)&cname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\\2/\',\'\\3\')';
		
		
		//android资讯分类分页列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(news)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'index_\\3\')';
		
		//android资讯分类列表
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(news)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\',\'\\2\')';
		
		//android资讯详细
		$preg_searchs[] = "/\<a href\=\"(android).php\?ac=(newdetail)&cname=([a-zA-Z0-9]+?)&newid=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/news/\\3/\',\'\\4\')';
		
		//android资讯分类列表
		$preg_searchs[] = "/\<a href\=\"(android).php\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\',\'\\1\')';













//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\3/\',\'\\4_\\5\')';
		
		
		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\3/\',\'\\4\')';


		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\3/\',\'index_\\4\')';
		
		
		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&typelx=(game|soft)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\1/\',\'\\3\')';
		
		
//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&orderby=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\',\'\\3_\\4\')';
		
		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&orderby=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\',\'\\3\')';
		
		
		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\',\'index_\\3\')';
		
		//apple推荐
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(recommend)&type=(iphone|ipad)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\',\'\\1\')';
		
		//apple专辑列表分页
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(subject)&type=(iphone|ipad)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\',\'index_\\3\')';
		
		//apple专辑列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(subject)&type=(iphone|ipad)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\',\'\\1\')';
		//apple专辑详细列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(subdetail)&type=(iphone|ipad)&subjectid=([0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\3/\',\'index_\\4\')';
		
		//apple专辑详细列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(subdetail)&type=(iphone|ipad)&subjectid=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\1/\',\'\\3\')';
		
		//apple专辑列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(subdetail)&type=(iphone|ipad)&sname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\1/\\3/\',\'index_\\4\')';
		
		//apple专辑列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(subdetail)&type=(iphone|ipad)&sname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\1/\',\'\\3\')';
		
		//apple资讯分类分页列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(news)&type=(iphone|ipad)&cname=([a-zA-Z0-9]+?)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\\3/\',\'index_\\4\')';
		
		//apple资讯分类列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(news)&type=(iphone|ipad)&cname=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\\1/\',\'\\3\')';
		
		
		//apple资讯分类分页列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(news)&type=(iphone|ipad)&page=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/\\1/\',\'index_\\3\')';
		
		//apple资讯分类列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(news)&type=(iphone|ipad)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\2/\',\'\\1\')';
		
		//apple资讯详细
		$preg_searchs[] = "/\<a href\=\"apple.php\?ac=(newdetail)&type=(iphone|ipad)&cname=([a-zA-Z0-9]+?)&newid=([0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2/news/\\3/\',\'\\4\')';
		
		//apple资讯分类列表
		$preg_searchs[] = "/\<a href\=\"apple.php\?type=(iphone|ipad)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\',\'\\1\')';

		//$preg_searchs[] = "/\<a href\=\"space\.php\?(uid|do)+\=([a-z0-9\=\&]+?)\"/ie";
		//$preg_searchs[] = "/\<a href\=\"space.php\"/i";
		//$preg_searchs[] = "/\<a href\=\"network\.php\?ac\=([a-z0-9\=\&]+?)\"/ie";
		//$preg_searchs[] = "/\<a href\=\"network.php\"/i";
		
		
		//小游戏相关的重写规则
		//$preg_searchs[] = "/\<a href\=\"catalog.php\?(n)+\=([a-zA-Z0-9\=\&]+?)\"/ie";//类别
		//$preg_searchs[] = "/\<a href\=\"subject.php\?(n)+\=([a-zA-Z0-9\=\&]+?)\"/ie";//专辑
		//$preg_searchs[] = "/\<a href\=\"search.php\?(key)+\=(.*)\"/ie";//搜索
		//$preg_searchs[] = "/\<a href\=\"detail.php\?(n)+\=([a-zA-Z0-9~\_\-\.\=\&]+?)\"/ie";//游戏的detail页
		//$preg_searchs[] = "/\<a href\=\"play.php\?(n)+\=([a-zA-Z0-9~\_\-\=\&]+?)\"/ie";//游戏的play页
		//$preg_searchs[] = "/\<a href\=\"rank.php\?(n)+\=([a-zA-Z0-9\=\&]+?)\"/ie";//游戏的rank页
		//$preg_searchs[] = "/\<a href\=\"recommend.php\?(n)+\=([a-zA-Z0-9\=\&]+?)\"/ie";//游戏的rank页
		//$preg_searchs[] = "/\<a href\=\"tags.php\?(n)+\=(.*)\"/ie";//tags
		
		//$preg_replaces[] = 'rewrite_url(\'space-\',\'\\2\')';
		//$preg_replaces[] = '<a href="space.html"';
		//$preg_replaces[] = 'rewrite_url(\'network-\',\'\\1\')';
		//$preg_replaces[] = '<a href="network.html"';

		//小游戏相关的重写规则
		/*
		$preg_replaces[] = 'rewrite_url(\'/catalog/\',\'\\2\')';
		$preg_replaces[] = 'rewrite_url(\'/subject/\',\'\\2\')';
		//$preg_replaces[] = 'rewrite_mulu_url(\'/search/\',\'\\2\')';
		$preg_replaces[] = 'rewrite_url(\'/detail/\',\'\\2\')';
		$preg_replaces[] = 'rewrite_url(\'/play/\',\'\\2\')';
		$preg_replaces[] = 'rewrite_url(\'/rank/\',\'\\2\')';
		$preg_replaces[] = 'rewrite_url(\'/recommend/\',\'\\2\')';
		//$preg_replaces[] = 'rewrite_mulu_url(\'/tags/\',\'\\2\')';
		*/
		
		/*
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(subject)&n=(subjectmap)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\',\'\\2\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(help)&op=([a-zA-Z0-9]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\',\'\\2\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(catalog)&n=(([a-zA-Z0-9\=\(\)\_\（\）\!\！\?\？]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\',\'\\2youxi\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(catalog)&n=(([a-zA-Z0-9\=\(\)\_\（\）\!\！\?\？]|[\x80-\xff]|[\s])+?)&(([a-zA-Z0-9\=\(\)\_\（\）\&]|[\x80-\xff])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2youxi/\',\'\\4\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(search)&key=(([a-zA-Z0-9\=\&\(\)\_\（\）\.\!\！\?\？]|[\x80-\xff]|[\s])+?)&(([a-zA-Z0-9\=\(\)\_\（\）\&]|[\x80-\xff])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/search/\\2/\',\'\\4\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(search)&key=(([a-zA-Z0-9\=\&\(\)\_\（\）\.\!\！\?\？]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/search/\',\'\\2\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(personal)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\',\'\\1\')';
		//$preg_searchs[] = "/\<a href\=\"index.php\?ac=(subject)&n=(([a-zA-Z0-9\=\(\)\_\（\）]|[\x80-\xff])+?)&(([a-zA-Z0-9\=\(\)\_\（\）]|[\x80-\xff])+?)\"/ie";
		//$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'\\3\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(recommend|rank|tags)&n=(([a-zA-Z0-9\=\(\)\_\（\）\!\！\?\？]|[\x80-\xff]|[\s])+?)(\&)(([a-zA-Z0-9\=\(\)\_\（\）\&]|[\x80-\xff])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\\2/\',\'\\5\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(subject)&n=(([a-zA-Z0-9\=\(\)\_\（\）\!\！\?\？]|[\x80-\xff]|[\s])+?)(\&)(([a-zA-Z0-9\=\(\)\_\（\）\&]|[\x80-\xff])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/games/\\2/\',\'\\5\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(recommend|rank|tags)&n=(([a-zA-Z0-9\=\(\)\_\（\）\!\！\?\？]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\\1/\',\'\\2\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(sitemap)&(([a-zA-Z0-9\=\(\)\_\（\）\&]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\',\'\\2\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(subject)&n=(([a-zA-Z0-9\=\(\)\_\（\）\!\！\?\？]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/games/\',\'\\2\')';
		
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(rank|recommend|tags|sitemap)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\',\'\\1\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(subject)\"/ie";
		$preg_replaces[] = 'rewrite_url2(\'/\',\'games\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(tags|recommend|rank)&page=(([a-zA-Z0-9\=\&\(\)\_\（\）\.]|[\x80-\xff])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\',\'page-\\2\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(subject)&page=(([a-zA-Z0-9\=\&\(\)\_\（\）\.]|[\x80-\xff])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url3(\'/games/\',\'page-\\2\')';
		
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(tags|recommend|rank)&(([a-zA-Z0-9\=\&\(\)\_\（\）\.]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\',\'\\2\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(subject)&(([a-zA-Z0-9\=\&\(\)\_\（\）\.]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/games/\',\'\\2\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(personal)&do=(([a-zA-Z0-9\=\&\(\)\_\（\）\.]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\',\'\\2\')';
		
		
		
			$preg_searchs[] = "/\<a href\=\"index.php\?ac=(detail)&cat=(([a-zA-Z0-9\=\&\(\)\_\（\）\.]|[\x80-\xff])+?)&n=(([a-zA-Z0-9\=\&\(\)\_\（\）\.\!\！\?\？\,\，\:\：\]\[\}\{]|[\x80-\xff]|[\s]|[@])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2youxi/\',\''.$_SCONFIG['rewritepre'].'\\4\')';
		
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=(play)&cat=(([a-zA-Z0-9\=\&\(\)\_\（\）\.\!\！\?\？]|[\x80-\xff])+?)&n=(([a-zA-Z0-9\=\&\(\)\_\（\）\.\!\！\?\？\,\，\:\：\]\[\}\{]|[\x80-\xff]|[\s]|[@])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\2youxi/\',\''.$_SCONFIG['rewritepre'].'\\4_1\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=([a-zA-Z0-9\=\&]+?)&n=(([a-zA-Z0-9\=\&\(\)\_\（\）\.\!\！\?\？]|[\x80-\xff]|[\s])+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\',\'\\2\')';
		$preg_searchs[] = "/\<a href\=\"index.php\?ac=([a-zA-Z0-9\=\&]+?)\"/ie";
		$preg_replaces[] = 'rewrite_url(\'/\\1/\',\'index\')';
		*/
	}
	if($_SCONFIG['linkguide']) {
		$preg_searchs[] = "/\<a href\=\"http\:\/\/(.+?)\"/ie";
		$preg_replaces[] = 'iframe_url(\'\\1\')';
	}
	
	if($_SGLOBAL['inajax']) {
		$preg_searchs[] = "/([\x01-\x09\x0b-\x0c\x0e-\x1f])+/";
		$preg_replaces[] = ' ';
		
		$str_searchs[] = ']]>';
		$str_replaces[] = ']]&gt;';
	}
	
	if($preg_searchs) {
		$content = preg_replace($preg_searchs, $preg_replaces, $content);
	}
	if($str_searchs) {
		$content = trim(str_replace($str_searchs, $str_replaces, $content));
	}
	
	obclean();
	if($_SGLOBAL['inajax']) {
		xml_out($content);
	} else{
		if($_SCONFIG['headercharset']) {
			@header('Content-Type: text/html; charset='.$_SC['charset']);
		}
		echo $content;
		if(D_BUG) {
			@include_once(S_ROOT.'./source/inc_debug.php');
		}
	}
}

function xml_out($content) {
	global $_SC;
	@header("Expires: -1");
	@header("Cache-Control: no-store, private, post-check=0, pre-check=0, max-age=0", FALSE);
	@header("Pragma: no-cache");
	@header("Content-type: application/xml; charset=$_SC[charset]");
	echo '<'."?xml version=\"1.0\" encoding=\"$_SC[charset]\"?>\n";
	echo "<root><![CDATA[".trim($content)."]]></root>";
	exit();
}

//rewrite链接
function rewrite_url($pre, $para) {
	$para = str_replace(array('&','='), array('-', '-'), $para);
	return '<a href="'.$pre.$para.'.htm"';
}
function rewrite_url3($pre, $para) {
	$para = str_replace(array('&','='), array('-', '-'), $para);
	return '<a href="'.$pre.$para.'.htm#sub"';
}
function rewrite_url2($pre, $para) {
	$para = str_replace(array('&','='), array('-', '-'), $para);
	return '<a href="'.$pre.$para.'/"';
}

//rewrite链接
function rewrite_mulu_url($pre, $para) {
	$para = str_replace(array('&','='), array('/', '-'), $para);
	return '<a href="'.$pre.$para.'/"';
}

////rewrite链接
//function rewrite_mulu_url($pre, $para) {
//	$para = str_replace(array('&','='), array('/', '/'), $para);
//	$para=str_replace("game/","",$para);
//	$para=str_replace("type/","",$para);
//	if(stripos($para,"id"))
//	{
//		$para=str_replace("id/","",$para);
//		return '<'.$pre.$para.'.htm"';
//	}
//	return '<'.$pre.$para.'/"';
//}

//外链
function iframe_url($url) {
	$url = rawurlencode($url);
	return "<a href=\"link.php?url=http://$url\"";
}

//处理搜索关键字
function stripsearchkey($string) {
	$string = trim($string);
	$string = str_replace('*', '%', addcslashes($string, '%_'));
	$string = str_replace('_', '\_', $string);
	return $string;
}



//是否屏蔽二级域名
function isholddomain($domain) {
	global $_SCONFIG;
	
	$domain = strtolower($domain);
	
	if(preg_match("/^[^a-z]/i", $domain)) return true;
	$holdmainarr = empty($_SCONFIG['holddomain'])?array('www'):explode('|', $_SCONFIG['holddomain']);
	$ishold = false;
	foreach ($holdmainarr as $value) {
		if(strpos($value, '*') === false) {
			if(strtolower($value) == $domain) {
				$ishold = true;
				break;
			}
		} else {
			$value = str_replace('*', '', $value);
			if(@preg_match("/$value/i", $domain)) {
				$ishold = true;
				break;
			}
		}
	}
	return $ishold;
}

//连接字符
function simplode($ids) {
	return "'".implode("','", $ids)."'";
}

//显示进程处理时间
function debuginfo() {
	global $_SGLOBAL, $_SC, $_SCONFIG;
	
	if(empty($_SCONFIG['debuginfo'])) {
		$info = '';
	} else {
		$mtime = explode(' ', microtime());
		$totaltime = number_format(($mtime[1] + $mtime[0] - $_SGLOBAL['supe_starttime']), 4);
		$info = 'Processed in '.$totaltime.' second(s), '.$_SGLOBAL['db']->querynum.' queries'.
			($_SC['gzipcompress'] ? ', Gzip enabled' : NULL);
	}
	
	return $info;
}

//格式化大小函数
function formatsize($size) {
	$prec=3;
	$size = round(abs($size));
	$units = array(0=>" B ", 1=>" KB", 2=>" MB", 3=>" GB", 4=>" TB");
	if ($size==0) return str_repeat(" ", $prec)."0$units[0]";
	$unit = min(4, floor(log($size)/log(2)/10));
	$size = $size * pow(2, -10*$unit);
	$digi = $prec - 1 - floor(log($size)/log(10));
	$size = round($size * pow(10, $digi)) * pow(10, -$digi);
	return $size.$units[$unit];
}

//获取文件内容
function sreadfile($filename) {
	$content = '';
	if(function_exists('file_get_contents')) {
		@$content = file_get_contents($filename);
	} else {
		if(@$fp = fopen($filename, 'r')) {
			@$content = fread($fp, filesize($filename));
			@fclose($fp);
		}
	}
	return $content;
}

//写入文件
function swritefile($filename, $writetext, $openmod='w') {
	if(@$fp = fopen($filename, $openmod)) {
		flock($fp, 2);
		fwrite($fp, $writetext);
		fclose($fp);
		return true;
	} else {
		runlog('error', "File: $filename write error.");
		return false;
	}
}

//产生随机字符
function random($length, $numeric = 0) {
	PHP_VERSION < '4.2.0' ? mt_srand((double)microtime() * 1000000) : mt_srand();
	$seed = base_convert(md5(print_r($_SERVER, 1).microtime()), 16, $numeric ? 10 : 35);
	$seed = $numeric ? (str_replace('0', '', $seed).'012340567890') : ($seed.'zZ'.strtoupper($seed));
	$hash = '';
	$max = strlen($seed) - 1;
	for($i = 0; $i < $length; $i++) {
		$hash .= $seed[mt_rand(0, $max)];
	}
	return $hash;
}

//判断字符串是否存在
function strexists($haystack, $needle) {
	return !(strpos($haystack, $needle) === FALSE);
}

//获取数据
function data_get($var, $isarray=0) {
	global $_SGLOBAL;
	
	//$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('data')." WHERE var='$var' LIMIT 1");
	//if($value = $_SGLOBAL['db']->fetch_array($query)) {
	//	return $isarray?$value:$value['datavalue'];
	//} else {
		return '';
	//}
}

//更新数据
function data_set($var, $datavalue, $clean=0) {
	global $_SGLOBAL;
	
	if($clean) {
		$_SGLOBAL['db']->query("DELETE FROM ".tname('data')." WHERE var='$var'");
	} else {
		if(is_array($datavalue)) $datavalue = serialize(sstripslashes($datavalue));
		$_SGLOBAL['db']->query("REPLACE INTO ".tname('data')." (var, datavalue, dateline) VALUES ('$var', '".addslashes($datavalue)."', '$_SGLOBAL[timestamp]')");
	}
}

//检查站点是否关闭
function checkclose() {
	global $_SGLOBAL, $_SCONFIG;
	
	//站点关闭
	if($_SCONFIG['close'] && !ckfounder($_SGLOBAL['supe_uid'])) {
		if(empty($_SCONFIG['closereason'])) {
			showmessage('site_temporarily_closed');
		} else {
			showmessage($_SCONFIG['closereason']);
		}
	}
	//IP访问检查
	if((!ipaccess($_SCONFIG['ipaccess']) || ipbanned($_SCONFIG['ipbanned'])) && !ckfounder($_SGLOBAL['supe_uid']) && !checkperm('closeignore')) {
		showmessage('ip_is_not_allowed_to_visit');
	}
}

//站点链接
function getsiteurl() {
	global $_SCONFIG;
	
	if(empty($_SCONFIG['siteallurl'])) {
		$uri = $_SERVER['REQUEST_URI']?$_SERVER['REQUEST_URI']:($_SERVER['PHP_SELF']?$_SERVER['PHP_SELF']:$_SERVER['SCRIPT_NAME']);
		return shtmlspecialchars('http://'.$_SERVER['HTTP_HOST'].substr($uri, 0, strrpos($uri, '/')+1));
	} else {
		return $_SCONFIG['siteallurl'];
	}
}

//获取文件名后缀
function fileext($filename) {
	return strtolower(trim(substr(strrchr($filename, '.'), 1)));
}

//去掉slassh
function sstripslashes($string) {
	if(is_array($string)) {
		foreach($string as $key => $val) {
			$string[$key] = sstripslashes($val);
		}
	} else {
		$string = stripslashes($string);
	}
	return $string;
}

//显示广告
function adshow($pagetype) {
	global $_SGLOBAL;
	
	@include_once(S_ROOT.'./data/data_ad.php');
	if(empty($_SGLOBAL['ad']) || empty($_SGLOBAL['ad'][$pagetype])) return false;
	$ads = $_SGLOBAL['ad'][$pagetype];
	$key = mt_rand(0, count($ads)-1);
	$id = $ads[$key];
	$file = S_ROOT.'./data/adtpl/'.$id.'.htm';
	echo sreadfile($file);
}

//编码转换
function siconv($str, $out_charset, $in_charset='') {
	global $_SC;
	
	$in_charset = empty($in_charset)?strtoupper($_SC['charset']):strtoupper($in_charset);
	$out_charset = strtoupper($out_charset);
	if($in_charset != $out_charset) {
		if (function_exists('iconv') && (@$outstr = iconv("$in_charset//IGNORE", "$out_charset//IGNORE", $str))) {
			return $outstr;
		} elseif (function_exists('mb_convert_encoding') && (@$outstr = mb_convert_encoding($str, $out_charset, $in_charset))) {
			return $outstr;
		}
	}
	return $str;//转换失败
}

//获取用户数据
function getpassport($username, $password) {
	global $_SGLOBAL, $_SC;
	
	$passport = array();
	$sql="SELECT * FROM ".tname("user")." WHERE username='$username'";
	
	$user = $_SGLOBAL['db']->fetch_first($sql);
	if(empty($user['username'])) {
		return 0;
	} elseif($user['password'] != md5(md5($password).$user['salt'])) {
		return 0;
	}
	$_SGLOBAL['is_admin'] = $user['is_admin'];
	$passport['uid'] = $user[uid];
	$passport['username'] = $user[username];
	$passport['email'] = $user[email];	
	$passport['password'] = $user[password];	
	return $passport;
}


/******************************************************
**************获取用户数据(邮箱登陆)2010-06-07***********
*******************************************************/
function getpassportbyemail($email, $password) {
	global $_SGLOBAL, $_SC;
	
	$passport = array();
	if(!@include_once S_ROOT.'./uc_client/client.php') {
		showmessage('system_error');
	}
	
	$ucresult = uc_user_login($email, $password,0,0,'','',1);
	if($ucresult[0] > 0) {
		$passport['uid'] = $ucresult[0];
		$passport['username'] = $ucresult[1];
		$passport['email'] = $ucresult[3];
	}
	return $passport;
}


//用户操作时间间隔检查
function interval_check($type) {
	global $_SGLOBAL, $space;
	
	$intervalname = $type.'interval';
	$lastname = 'last'.$type;
	
	$waittime = 0;
//	if($interval = checkperm($intervalname)) {
//		$lasttime = isset($space[$lastname])?$space[$lastname]:getcount('space', array('uid'=>$_SGLOBAL['supe_uid']), $lastname);
//		$waittime = $interval - ($_SGLOBAL['timestamp'] - $lasttime);
//	}
	return $waittime;
}


//处理积分星星
function getstar($experience) {
	global $_SCONFIG;
	
	$starimg = '';
	if($_SCONFIG['starcredit'] > 1) {
		//计算星星数
		$starnum = intval($experience/$_SCONFIG['starcredit']) + 1;
		if($_SCONFIG['starlevelnum'] < 2) {
			if($starnum > 10) $starnum = 10;
			for($i = 0; $i < $starnum; $i++) {
				$starimg .= '<img src="image/star_level10.gif" align="absmiddle" />';
			}
		} else {
			//计算等级(10个)
			for($i = 10; $i > 0; $i--) {
				$numlevel = intval($starnum / pow($_SCONFIG['starlevelnum'], ($i - 1)));
				if($numlevel > 10) $numlevel = 10;
				if($numlevel) {
					for($j = 0; $j < $numlevel; $j++) {
						$starimg .= '<img src="image/star_level'.$i.'.gif" align="absmiddle" />';
					}
					break;
				}
			}
		}
	}
	if(empty($starimg)) $starimg = '<img src="image/credit.gif" alt="'.$experience.'" align="absmiddle" alt="'.$experience.'" title="'.$experience.'" />';
	return $starimg;
}


//重新组建
function renum($array) {
	$newnums = $nums = array();
	foreach ($array as $id => $num) {
		$newnums[$num][] = $id;
		$nums[$num] = $num;
	}
	return array($nums, $newnums);
}

//ip访问允许
function ipaccess($ipaccess) {
	return empty($ipaccess)?true:preg_match("/^(".str_replace(array("\r\n", ' '), array('|', ''), preg_quote($ipaccess, '/')).")/", getonlineip());
}

//ip访问禁止
function ipbanned($ipbanned) {
	return empty($ipbanned)?false:preg_match("/^(".str_replace(array("\r\n", ' '), array('|', ''), preg_quote($ipbanned, '/')).")/", getonlineip());
}

//检查start
function ckstart($start, $perpage) {
	global $_SCONFIG;
	
	$maxstart = $perpage*intval($_SCONFIG['maxpage']);
	if($start < 0 || ($maxstart > 0 && $start >= $maxstart)) {
		showmessage('length_is_not_within_the_scope_of');
	}
}

//处理头像
function avatar($uid, $size='small', $returnsrc = FALSE) {
	global $_SCONFIG, $_SN,$_SC;
	
	$size = in_array($size, array('big', 'middle', 'small')) ? $size : 'small';
	$avatarfile = avatar_file($uid, $size);
	return $returnsrc ? $_SC['dataurl'].'/data/avatar/'.$avatarfile : '<img src="'.$_SC['dataurl'].'/data/avatar/'.$avatarfile.'" onerror="this.onerror=null;this.src=\''.'/image/noavatar_'.$size.'.gif\'">';
}

//得到头像
function avatar_file($uid, $size) {
	global $_SGLOBAL, $_SCONFIG;
	
	$type = empty($_SCONFIG['avatarreal'])?'virtual':'real';
	$var = "avatarfile_{$uid}_{$size}_{$type}";
	$_SGLOBAL[$var]="";
	if(empty($_SGLOBAL[$var])) {
		$uid = abs(intval($uid));
		$uid = sprintf("%09d", $uid);
		$dir1 = substr($uid, 0, 3);
		$dir2 = substr($uid, 3, 2);
		$dir3 = substr($uid, 5, 2);
		$typeadd = $type == 'real' ? '_real' : '';
		$_SGLOBAL[$var] = $dir1.'/'.$dir2.'/'.$dir3.'/'.substr($uid, -2).$typeadd."_avatar_$size.jpg";
	}
	return $_SGLOBAL[$var];
}

//检查是否登录
function checklogin() {
	global $_SGLOBAL, $_SCONFIG;
	
	if(empty($_SGLOBAL['supe_uid'])) {
		ssetcookie('_refer', rawurlencode($_SERVER['REQUEST_URI']));
		showmessage('to_login', 'index.php?ac=login');
	}
}

//获得前台语言
function lang($key, $vars=array()) {
	global $_SGLOBAL;
	
	/*include_once(S_ROOT.'./language/lang_source.php');
	if(isset($_SGLOBAL['sourcelang'][$key])) {
		$result = lang_replace($_SGLOBAL['sourcelang'][$key], $vars);
	} else {
		$result = $key;
	}
	return $result;
	*/
}

//获得后台语言
function cplang($key, $vars=array()) {
	global $_SGLOBAL;
	/*
	include_once(S_ROOT.'./language/lang_cp.php');
	if(isset($_SGLOBAL['cplang'][$key])) {
		$result = lang_replace($_SGLOBAL['cplang'][$key], $vars);
	} else {
		$result = $key;
	}
	return $result;
	*/
}

//语言替换
function lang_replace($text, $vars) {
	if($vars) {
		foreach ($vars as $k => $v) {
			$rk = $k + 1;
			$text = str_replace('\\'.$rk, $v, $text);
		}
	}
	return $text;
}

//获得用户组名
function getfriendgroup() {
	global $_SCONFIG, $space;
	
	$groups = array();
	$spacegroup = empty($space['privacy']['groupname'])?array():$space['privacy']['groupname'];
	for($i=0; $i<$_SCONFIG['groupnum']; $i++) {
		if($i == 0) {
			$groups[0] = lang('friend_group_default');
		} else {
			if(!empty($spacegroup[$i])) {
				$groups[$i] = $spacegroup[$i];
			} else {
				if($i<8) {
					$groups[$i] = lang('friend_group_'.$i);
				} else {
					$groups[$i] = lang('friend_group').$i;
				}
			}
		}
	}
	return $groups;
}

//截取链接
function sub_url($url, $length) {
	if(strlen($url) > $length) {
		$url = str_replace(array('%3A', '%2F'), array(':', '/'), rawurlencode($url));
		$url = substr($url, 0, intval($length * 0.5)).' ... '.substr($url, - intval($length * 0.3));
	}
	return $url;
}

//取数组中的随机个
function sarray_rand($arr, $num=1) {
	$r_values = array();
	if($arr && count($arr) > $num) {
		if($num > 1) {
			$r_keys = array_rand($arr, $num);
			foreach ($r_keys as $key) {
				$r_values[$key] = $arr[$key];
			}
		} else {
			$r_key = array_rand($arr, 1);
			$r_values[$r_key] = $arr[$r_key];
		}
	} else {
		$r_values = $arr;
	}
	return $r_values;
}

//获得用户唯一串
function space_key($space, $appid=0) {
	global $_SCONFIG;
	return substr(md5($_SCONFIG['sitekey'].'|'.$space['uid'].(empty($appid)?'':'|'.$appid)), 8, 16);
}

//获得用户URL
function space_domain($space) {
	global $_SCONFIG;
	
	if($space['domain'] && $_SCONFIG['allowdomain'] && $_SCONFIG['domainroot']) {
		$space['domainurl'] = 'http://'.$space['domain'].'.'.$_SCONFIG['domainroot'];
	} else {
		if($_SCONFIG['allowrewrite']) {
			$space['domainurl'] = getsiteurl().$space[uid];
		} else {
			$space['domainurl'] = getsiteurl()."?$space[uid]";
		}
	}
	return $space['domainurl'];
}

//产生form防伪码
function formhash() {
	global $_SGLOBAL, $_SCONFIG;
	
	if(empty($_SGLOBAL['formhash'])) {
		$hashadd = defined('IN_ADMINCP') ? 'Only For UCenter Home AdminCP' : '';
		$_SGLOBAL['formhash'] = substr(md5(substr($_SGLOBAL['timestamp'], 0, -7).'|'.$_SGLOBAL['supe_uid'].'|'.md5($_SCONFIG['sitekey']).'|'.$hashadd), 8, 8);
	}
	return $_SGLOBAL['formhash'];
}

//检查邮箱是否有效
function isemail($email) {
	return strlen($email) > 6 && preg_match("/^[\w\-\.]+@[\w\-\.]+(\.\w+)+$/", $email);
}

//验证提问
function question() {
	global $_SGLOBAL;
	
	include_once(S_ROOT.'./data/data_spam.php');
	if($_SGLOBAL['spam']['question']) {
		$count = count($_SGLOBAL['spam']['question']);
		$key = $count>1?mt_rand(0, $count-1):0;
		ssetcookie('seccode', $key);
		echo $_SGLOBAL['spam']['question'][$key];
	}
}

//获得用户组图标
function g_icon($gid) {
	global $_SGLOBAL;
	include_once(S_ROOT.'./data/data_usergroup.php');
	if(empty($_SGLOBAL['grouptitle'][$gid]['icon'])) {
		echo '';
	} else {
		echo ' <img src="'.$_SGLOBAL['grouptitle'][$gid]['icon'].'" align="absmiddle"> ';
	}
}

//获得用户颜色
function g_color($gid) {
	global $_SGLOBAL;
	include_once(S_ROOT.'./data/data_usergroup.php');
	if(empty($_SGLOBAL['grouptitle'][$gid]['color'])) {
		echo '';
	} else {
		echo ' style="color:'.$_SGLOBAL['grouptitle'][$gid]['color'].';"';
	}
}

//检查是否操作创始人
function ckfounder($uid) {
	global $_SC;
	
	$founders = empty($_SC['founder'])?array():explode(',', $_SC['founder']);
	if($uid && $founders) {
		return in_array($uid, $founders);
	} else {
		return false;
	}
}

//获取目录
function sreaddir($dir, $extarr=array()) {
	$dirs = array();
	if($dh = opendir($dir)) {
		while (($file = readdir($dh)) !== false) {
			if(!empty($extarr) && is_array($extarr)) {
				if(in_array(strtolower(fileext($file)), $extarr)) {
					$dirs[] = $file;
				}
			} else if($file != '.' && $file != '..') {
					$dirs[] = $file;
				}
		}
		closedir($dh);
	}
	return $dirs;
}


//自定义分页
function mob_perpage($perpage) {
	global $_SGLOBAL;
	
	$newperpage = isset($_GET['perpage'])?intval($_GET['perpage']):0;
	if($_SGLOBAL['mobile'] && $newperpage>0 && $newperpage<500) {
		$perpage = $newperpage;
	}
	return $perpage;
}

//检查用户的特殊身份
function ckspacelog() {
	global $_SGLOBAL;
	
	if(empty($_SGLOBAL['supe_uid'])) return false;
	$query = $_SGLOBAL['db']->query("SELECT * FROM ".tname('spacelog')." WHERE uid='$_SGLOBAL[supe_uid]'");
	if($value = $_SGLOBAL['db']->fetch_array($query)) {
		if($value['expiration'] && $value['expiration'] <= $_SGLOBAL['timestamp']) {//到期
			$_SGLOBAL['db']->query("DELETE FROM ".tname('spacelog')." WHERE uid='$_SGLOBAL[supe_uid]'");
		}
		$expiration = sgmdate('Y-m-d H:i', $value['expiration']);
		showmessage('no_authority_expiration'.($value['expiration']?'_date':''), '', 1, array($expiration));
	}
}

//add by hmf

//Q版表情标签处理
function joke_bbcode($message) {
	$message = preg_replace("/\[joke\=?(\d\d\d)*\](.*?)\[\/joke\]/ie", "joke_flash('\\2', '\\1')", $message);
	return $message;
}
//视频
function joke_flash($tips, $iconid='') {
	$width = '48';
	$height = '48';
	$rand=rand(1,100000);
	$html='<div ><div class="audible" style="float: left;">';
	$html.= '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" width="'.$width.'" height="'.$height.'" id="toy_'.$iconid.'_'.$rand.'">
			<param name="movie" value="image/joke/base_'.$iconid.'.swf">
			<param name="allowscriptaccess" value="always">
			<embed name="toy_'.$iconid.'_'.$rand.'" src="image/joke/base_'.$iconid.'.swf" type="application/x-shockwave-flash" width="'.$width.'" height="'.$height.'" allowfullscreen="true" allowscriptaccess="always"></embed>
			</object>';
	$html.= '</div>';
	$html.='<span>'.$tips.'<br/><a href="javascript:window.document.toy_'.$iconid.'_'.$rand.'.Play();void(0);" class="playswf '.$iconid.'">播放声音</a></span></div>';		
	
	return $html;
}

/*
* string get_zodiac_sign(string month, string day)
* 输入：月份，日期
* 输出：星座名称或者错误
*/
function get_zodiac_sign($month, $day)
{
	// 检查参数有效性
	if ($month < 1 || $month > 12 || $day < 1 || $day > 31)
		return (false);
	
	// 星座名称以及开始日期
	$signs = array(
			array( "20" => "宝瓶座"),
			array( "19" => "双鱼座"),
			array( "21" => "白羊座"),
			array( "20" => "金牛座"),
			array( "21" => "双子座"),
			array( "22" => "巨蟹座"),
			array( "23" => "狮子座"),
			array( "23" => "处女座"),
			array( "23" => "天秤座"),
			array( "24" => "天蝎座"),
			array( "22" => "射手座"),
			array( "22" => "摩羯座")
			);
	list($sign_start, $sign_name) = each($signs[(int)$month-1]);
	if ($day < $sign_start)
		list($sign_start, $sign_name) = each($signs[($month -2 < 0) ? $month = 11: $month -= 2]);
	return $sign_name;
	
}

/**
 * 更新图片的地址。当出现QQ.com时返回为空
 *
 * @param mixed $pic This is a description
 * @return mixed This is the return value description
 *
 */
function replace_pic($pic)
{
	//if(strstr($pic,"qq.com")||strstr($pic,"kaixin001.com")||strstr($pic,"baidu.com"))
	if(!empty($pic))
	{
		if(strstr($pic,"http://"))
		{					
			$pic="image.php?url=".$pic;
			if(strstr($pic,"qq.com"))
				$pic="";
		}
	}
	return $pic;
}


//显示进程处理时间 add by hmf
function m_debuginfo() {
	global $_SGLOBAL, $_SC, $_SCONFIG;
	
	if(empty($_SCONFIG['debuginfo'])) {
		$info = '';
	} else {
		$mtime = explode(' ', microtime());
		$totaltime = number_format(($mtime[1] + $mtime[0] - $_SGLOBAL['supe_starttime']), 4);
		$info = 'Processed in '.$totaltime.' second(s), '.$_SGLOBAL['db']->querynum.' queries'.
			($_SC['gzipcompress'] ? ', Gzip enabled' : NULL);
	}
	
	return $info;
}





function multi2($num, $perpage, $curpage, $mpurl, $ajaxdiv='', $todiv='') {
	global $_SCONFIG, $_SGLOBAL;
	
	if(empty($ajaxdiv) && $_SGLOBAL['inajax']) {
		$ajaxdiv = $_GET['ajaxdiv'];
	}
	
	$page =10;
	if($_SGLOBAL['showpage']) $page = $_SGLOBAL['showpage'];
	
	$multipage = '';
	$mpurl .= strpos($mpurl, '?') ? '&' : '?';
	$realpages = 1;
	if($num > $perpage) {
		$offset = 2;
		$realpages = @ceil($num / $perpage);
		$pages = $_SCONFIG['maxpage'] && $_SCONFIG['maxpage'] < $realpages ? $_SCONFIG['maxpage'] : $realpages;
		if($page > $pages) {
			$from = 1;
			$to = $pages;
		} else {
			$from = $curpage - $offset;
			$to = $from + $page - 1;
			if($from < 1) {
				$to = $curpage + 1 - $from;
				$from = 1;
				if($to - $from < $page) {
					$to = $page;
				}
			} elseif($to > $pages) {
				$from = $pages - $page + 1;
				$to = $pages;
			}
		}
		$multipage = '';
		$urlplus = $todiv?"#$todiv":'';
		if($curpage > 1) {
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=".($curpage-1)."&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=".($curpage-1)."$urlplus\"";
			}
			$multipage .= " class=\"page_prev\">上一页</a>";
		}else{
        $multipage.="<span class=\"page_prev\">上一页</span>";
        }
		if($curpage - $offset > 1 && $pages > $page) {
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=1&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=1{$urlplus}\"";
			}
			$multipage .= ">1</a>";
			 $multipage.= "<span class=\"page_break\">...</span>";
		}

		for($i = $from; $i <= $to; $i++) {
			if($i == $curpage) {
				$multipage .= '<span class="page_cur">'.$i.'</span>';
			} else {
				$multipage .= "<a ";
				if($_SGLOBAL['inajax']) {
					$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=$i&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
				} else {
					$multipage .= "href=\"{$mpurl}page=$i{$urlplus}\"";
				}
				$multipage .= ">$i</a>";
			}
		}

		if($to < $pages) {
            $multipage.= "<span class=\"page_break\">...</span>";
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=$pages&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=$pages{$urlplus}\"";
			}
			$multipage .= ">$realpages</a>";
		}
		if($curpage < $pages) {
			$multipage .= "<a ";
			if($_SGLOBAL['inajax']) {
				$multipage .= "href=\"javascript:;\" onclick=\"ajaxget('{$mpurl}page=".($curpage+1)."&ajaxdiv=$ajaxdiv', '$ajaxdiv')\"";
			} else {
				$multipage .= "href=\"{$mpurl}page=".($curpage+1)."{$urlplus}\"";
			}
			$multipage .= " class=\"page_next\">下一页</a>";
		}else{
        $multipage.="<span class=\"page_next\">下一页</span>";
        }
	}
	return $multipage;
}

/**
 * 按ID生成目录。每个目录1000文件
 *
 * @param mixed $id This is a description
 * @return mixed This is the return value description
 *
 */
function get_path($id)
{
	$id = abs(intval($id));
	$id = sprintf("%06d", $id);
	
	$dir1 = substr($id, 0, 2);
	$dir2 = substr($id, 2, 2);
	return $dir1.'/'.$dir2.'/';
}
function check_website($siteid,$key){
	global $_SGLOBAL;
	$wsql="select count(*) from ".tname('website')." where siteid='".$siteid."' and wkey='".$key."'";
	$count=$_SGLOBAL['db']->result($_SGLOBAL['db']->query($wsql), 0);
	if($count==1){
		return true;
	}else{
		return false;
	}
}

?>
