﻿var Pages = {
    history : [],
    cache : {},
    perPage : 20,

    init : function(){
        this.load(document.location.href);

        var RESIZE_EV = 'onorientationchange' in window ? 'orientationchange' : 'resize';
        window.addEventListener(RESIZE_EV, function(){

            setTimeout(function(){
                Pages.resize();
            }, 500);
        });
    },

    showLoading : function(){
        $("#loadingPage").show();
    },

    hideLoading : function(){
        $("#loadingPage").hide();
    },

    template : function(tmpl,json){
        if (typeof tmpl !== "string" || typeof json !== "object") return "";
        return tmpl.replace(/\@{([a-zA-Z_0-9\-]*)\}/g, function (all, key) {
            return typeof json[key] !== "undefined" ? json[key] : ""
        });
    },

    bindLink : function(){
        var _this = this;

        $(".link").unbind("click").bind("click", function(e){
            e.preventDefault();
            if (this.getAttribute("target") == "_blank"){
                window.open(this.getAttribute("href"));
                return false;
            }
            var href = $(this).attr("href"),
                target = $(this).attr("target"),
                title = $(this).attr("title") || "4399安卓游戏";

            setTimeout(function(){

                var r = _this.parseRoute(href),
                    route = _this.parseRoute(document.location.href);

                if (r.host == route.host){
                    if (href !== "javascript:void(0)" && href !== "" && href !== "#" && href !=="javascript:history.back()"){
                        _this.load(href);
                        window.history.pushState('', title, href);
                    }
                } else {
                    document.location.href = href;
                }
            }, 0);
            return false;
        });

        $(".btn_back").unbind("click").bind("click", function(e){
            history.back();
            return false;
        });

        $(".hashover").unbind("touchstart").bind("touchstart", function(e){
            $(this).addClass("hover");
            e.stopPropagation();
        }).unbind("touchend").bind("touchend", function(e){
                $(this).removeClass("hover");
                e.stopPropagation();
            });

        if ($(".search_form").length > 0){
            $(".search_form").unbind("submit").bind("submit", function(e){
                var key = $.trim($(".search_form .input input").val()),
                    href = "index-m-searchResult.html?key=" + key;

                if (key !== ""){
                    $(".search_form .input input").trigger("blur");
                    _this.load(href);
                    window.history.pushState('', key, href);
                }
                e.preventDefault();
            });

            $(".btn_reset").unbind("click").bind("click", function(e){
                $(".search_form .input input").val("");
                e.preventDefault();
            });

            $(".search_form .input input").unbind("focus").bind("focus", function(){
                $(this).prev("label").hide();
            }).unbind("blur").bind("blur", function(){
                    if ($.trim($(this).val()) == ""){
                        $(this).prev("label").show();
                    }
                });
        }
    },

    bind : function(json, route, page, tab){
        var _this = this;

        $(".logo,.page_title").unbind("click").bind("click", function(){
            window.scrollTo(0, 0);
            return false;
        });

        _this.bindLink();

        $(".load_more").unbind("click").bind("click", function(){
            var $this = $(this),
                lastId = $(this).attr("data-lastId");

            if ($this.hasClass("nodata") || $this.hasClass("loading")){
                return false;
            }

            $this.addClass("loading").html("正在加载更多数据...");

            var target = tab ? tab : page;
            route.lastId = lastId;
            var url = _this.template(target.url, route);

            $.getJSON(url, { }, function(json){
                var perPage = target.perPage || Pages.perPage;

                if (Object.prototype.toString.call(target.updateTarget) =="[object Array]"){

                    var show_more = true;

                    for (var i = 0; i < target.updateTarget.length; i++){
                        var $updateTarget = $(target.updateTarget[i]),
                            list = json[target.listKey[i]];

                        if (list.length > 0){
                            $updateTarget.append($(target.tmpl).tmpl(list));

                            _this.bindLink();
                            (typeof page.onUpdate === "function") && page.onUpdate.call(page);
                        }

                        if (list.length < perPage){
                            show_more = false;
                        }
                    }

                    if (!show_more){
                        $this.removeClass("loading").addClass("nodata").html("暂无更多数据");
                    } else {
                        $this.attr("data-lastId", json.lastId);
                        $this.removeClass("loading").html("点击加载更多");
                    }
                } else {
                    var $updateTarget = $(target.updateTarget),
                        data= target.dataKey ? json[target.dataKey] : json,
                        list = data[target.listKey];

                    if (list.length > 0){
                        if (target.listKey == "list"){
                            $updateTarget.append($(target.tmpl).tmpl(list));
                        } else {
                            $updateTarget.append($(target.tmpl).tmpl(data));
                        }

                        _this.bindLink();
                        (typeof page.onUpdate === "function") && page.onUpdate.call(page);
                    }

                    if (target.listKey == "list"){
                        if (list.length < Pages.perPage){
                            $this.removeClass("loading").addClass("nodata").html("暂无更多数据");
                        } else {
                            $this.attr("data-lastId", data.lastId);
                            $this.removeClass("loading").html("点击加载更多");
                        }
                    } else {
                        if (data.count < Pages.perPage){
                            $this.removeClass("loading").addClass("nodata").html("暂无更多数据");
                        } else {
                            $this.attr("data-lastId", data.lastId);
                            $this.removeClass("loading").html("点击加载更多");
                        }
                    }
                }
            });
        });

        window.onpopstate = function(e) {
            Pages.showLoading();
            _this.load(location.href);
        };
    },

    parseRoute : function(url){
        var _this = this,
            a =  document.createElement('a'),
            param = {},
            page,
            tab,
            route = {};

        a.href = url;

        url = url.split("?");

        if (url[1]){
            param = url[1].split("&");
            for (var i = 0; i < param.length; i++){
                var arg = param[i].split("=");
                route[arg[0]] = arg[1];
            }
        }
        param = url[0].split("/");
        if (param[param.length - 1]){
            param = param[param.length - 1].split(/[\-\.]/);

            //去掉第一个和最后一个
            param.shift();
            param.pop();

            for (var i = 0; i < param.length / 2; i++){
                route[param[2 * i]] = param[2*i + 1];
            }
        }

        if(!route.m){
            route.m = 'index';
        }

        page = Pages[route.m + 'Page'];

        if (page.defaultTab){
            if(!route.tab){
                route.tab = page.defaultTab;
            }

            for(var i = 0; i < page.tabs.length; i++){
                if (route.tab == page.tabs[i].name){
                    tab = page.tabs[i];
                }
            }
        }

        return {route : route, page : page, tab : tab, host : a.hostname};
    },

    load : function(url){
        var _this = this,
            route = _this.parseRoute(url),
            page = route.page,
            tab = route.tab;

        route = route.route;
        url = _this.template(page.url, route);

        Pages.showLoading();

        if (_this.cache[url]){
            _this.loaded(_this.cache[url], route, page, tab);
            return;
        }



        $.getJSON(url, {}, function(json){

            //setTimeout(function(){
            _this.cache[url] = json;
            _this.loaded(json, route, page, tab);
            //}, 1000);
        });
    },

    loaded : function(json, route, page, tab){
        var prepage = this.history.pop();
        if (prepage){
            (typeof prepage.page.onDestroy === "function") && prepage.page.onDestroy.call(prepage.page);
        }

        if (page.menuIndex >= 0){
            $("#nav li").eq(page.menuIndex).addClass("cur").siblings().removeClass("cur");
        }

        this.history.push({route: route, page : page, tab : tab});
        (typeof page.onBeforeRender === "function") && page.onBeforeRender.call(page,json, route, page, tab);
        $("#main").html($("#" + route.m + "PageTmpl").tmpl({data : json, route : route}));
        Pages.hideLoading();
        Pages.bind(json, route, page, tab);
        typeof page.init === "function" && page.init(json, route, page, tab);

        setTimeout(function(){
            window.scrollTo(0, 1);
        },200);
    },

    resize : function(){
        var route = this.parseRoute(document.location.href);
        v_height = window.innerHeight || document.documentElement.clientHeight;
        v_width = window.innerWidth || document.documentElement.clientWidth;
        (typeof route.page.resize === "function") && route.page.resize();
    }
}

Pages.indexPage = {
    name : "index",
    perPage : 10,
    menuIndex : 0,
    updateTarget : [".game_list_1 ul.left", ".game_list_1 ul.right"],
    tmpl : "#gameListItemTmpl_1",
    listKey : ["new_list", "hot_list"],


    init : function(){
        var _this = this,
            $page = $("#" + _this.name + "Page");

        _this.slide = new Slide({
            items : "#indexSlide ul li",
            target : "#indexSlide ul",
            nav_target : "#indexSlide ol",
            width : v_width,
            ratio : 3.047
        });
    },

    resize : function(){
        this.slide.reset(v_width);
    }
}

Pages.specialPage = {
    name : "special",
    menuIndex : 1,
    updateTarget : ".special_list",
    tmpl : "#specialListTmpl",
    listKey : "dates",

    summarys : [],

    init : function(route){
        var _this = this,
            $page = $("#" + _this.name + "Page"),
            $fix_summary = $(".fixed_summary"),
            last_scroll_time = new Date();

        _this.slide = new Slide({
            items : "#specialSlide ul li",
            target : "#specialSlide ul",
            nav_target : "#specialSlide ol",
            width : v_width,
            ratio : 3.047
        });

        _this.getSummary();

        $(window).bind("scroll.fixed_summary", function(){
            if (new Date() - last_scroll_time < 100){
                return;
            }

            last_scroll_time = new Date();
            var scroll_y = window.scrollY;

            var first_summary = _this.summarys[0];

            if (scroll_y < first_summary.top - 48){
                $fix_summary.hide();
                return;
            }

            for (var i = _this.summarys.length - 1; i >=0 ; i--){
                if (scroll_y >= _this.summarys[i].top - 48){
                    $fix_summary.html(_this.summarys[i].obj.html()).show();
                    break;
                }
            }
        });
    },

    resize : function(){
        this.slide.reset(v_width);
    },

    getSummary : function(){
        var _this = this,
            $page = $("#" + _this.name + "Page");

        var $summarys = $page.find(".summary");
        _this.summarys = [];
        $summarys.each(function(){
            _this.summarys.push({obj : $(this), top : $(this).offset().top});
        });
    },

    onUpdate : function(){
        this.getSummary();
    },

    onDestroy : function(){
        $(window).unbind("scroll.fixed_summary");
    }
}

Pages.rankPage = {
    name : "rank",
    menuIndex : 2,
    defaultTab : "month",
    tabs : [{
        "name" : "month",
        "updateTarget" : ".game_list ul",
        "tmpl" : "#gameListItemTmpl",
        "dataKey" : "month_list",
        "listKey" : "list"
    },{
        "name" : "all",
        "updateTarget" : ".game_list ul",
        "tmpl" : "#gameListItemTmpl",
        "dataKey" : "all_list",
        "listKey" : "list"
    }]
}

Pages.categoryPage = {
    name : "category",
    menuIndex : 3
}

Pages.searchPage = {
    name : "search",
    menuIndex : 4,

    onBeforeRender : function(json){
        json.randomlist = [];
        var num = json.list.length >= 9 ? 9 : json.list.length;
        json.randomlist = this.getRandomArray(json.list, num);
        //json.key = json.randomlist.pop();
    },

    getRandomArray : function(arr, num){
        var new_arr = [],
            num = num < arr.length ? num : arr.length,
            old_arr = [];

        Array.prototype.push.apply(old_arr, arr);

        for (var i =0; i < num; i++){
            new_arr.push(old_arr.splice(Math.floor(Math.random() * old_arr.length) ,1)[0]);
        }

        return new_arr;
    }
}

Pages.searchResultPage = {
    name : "searchResult",
    menuIndex : 4,
    updateTarget : ".game_list ul",
    listKey : "list",
    tmpl : "#gameListItemTmpl"
}

Pages.gameListPage = {
    name : "gameList",
    menuIndex : 3,
    updateTarget : ".game_list ul",
    tmpl : "#gameListItemTmpl",
    listKey : "list"
}

Pages.specialDetailPage = {
    name : "specialDetail",
    menuIndex : 3
}

Pages.strategyDetailPage = {
    name : "strategyDetail",
    menuIndex : -1
}

Pages.detailPage = {
    name : "detail",
    menuIndex : -1,

    init : function(json, route, page, tab){
        var _this = this,
            $page = $("#" + _this.name + "Page");

        var pre_load_img = imgReady(json.detail.gallary[0], function(){
            var width;

            if (this.width >  this.height){
                $("#j-gallery").addClass("rotate");

                if ($(window).width() > 767){
                    width = 480;
                } else {
                    width = 300;
                }
            } else {
                if ($(window).width() > 767){
                    width = 270;
                } else {
                    width = 226;
                }
            }

            _this.slide = new Slide({
                items : "#j-gallery ul li",
                target : "#j-gallery ul",
                margin : 10,
                hasTap : false,
                nav_target : "#j-gallery ol",
                width : width
            });
        });


        var $more = $page.find(".game_desc .more"),
            $text = $page.find(".game_desc .text"),
            $text_in = $page.find(".game_desc .text_in"),
            height = parseInt($text.css("line-height")) * 2;

        $more.unbind("touchstart").bind("touchstart", function(){
            if ($(this).hasClass("show")){
                $(this).find("span").html("展开");
                $text.css("height", height);
            } else{
                $(this).find("span").html("收起");
                $text.css("height", $text_in.height());
            }
            $(this).toggleClass("show");
            return false;
        });

        if ($text.height() > height){
            $more.show();
            $text.css({
                "height" : height,
                "min-height" : height,
                "max-height" : 10000
            });
        }
    }
}

$(function(){
    Pages.init();
});

function Slide(options){
    this.cur = 0;
    this.options = $.extend({}, options);
    this.init();
}

Slide.prototype = {
    constructor : Slide,
    init : function(){
        var _this = this,
            items = $(this.options.items),
            target = $(this.options.target),
            hasTap = this.options.hasTap === false ? false : true,
            nav_target = $(this.options.nav_target),
            margin = this.options.margin || 0,
            width = this.options.width,
            ratio = this.options.ratio || 0,
            height;

        var is_touch_start = false;
        var start_x, end_x, start_y, end_y, margin_left;

        if (ratio > 0){
            height = Math.round(width / ratio);
            items.width(width).height(height).show();
            target.width(items.length * (width + margin)).height(height);
        } else {
            items.width(width).show();
            target.width(items.length * (width + margin));
        }

        for(var i = 0; i < items.length; i++){
            nav_target.append("<li></li>");
        }

        nav_target.find("li").eq(0).addClass("cur");

        target.unbind("touchstart").bind("touchstart", function(e){
            var $this = $(this),
                _this = this;
            if (is_touch_start) return false;

            is_touch_start = true;
            margin_left = parseInt(target.css("margin-left"));
            start_x = e.originalEvent.changedTouches[0].clientX;
            start_y = e.originalEvent.changedTouches[0].clientY;
        }).unbind("touchmove").bind("touchmove", function(e){
                var $this = $(this),
                    _this = this;
                if (!is_touch_start) return false;

                end_x = e.originalEvent.changedTouches[0].clientX;
                end_y = e.originalEvent.changedTouches[0].clientY;

                target.stop().css({
                    "margin-left" : end_x - start_x + margin_left
                });

                if (Math.abs(end_x - start_x) > 20 ){
                    e.preventDefault();
                }

            }).unbind("touchend").bind("touchend", function(e){
                is_touch_start = false;
                width = _this.options.width;
                var next = end_x - start_x > 0 ? _this.cur - 1 : _this.cur + 1;

                if (next >= 0 && next < items.length && Math.abs(end_x - start_x) > width / 3){
                    target.stop().animate({
                        "margin-left" : - next * (width + margin)
                    }, 200);

                    _this.cur = next;
                    nav_target.find("li").removeClass("cur").eq(_this.cur).addClass("cur");

                } else {
                    target.stop().animate({
                        "margin-left" : - _this.cur * (width + margin)
                    }, 200);
                }
            });
    },

    reset : function(width){
        var _this = this,
            items = $(this.options.items),
            target = $(this.options.target),
            margin = this.options.margin  || 0,
            nav_target = $(this.options.nav_target),
            ratio = this.options.ratio || 0,
            height;

        this.options.width = width;

        if (ratio > 0){
            height = Math.round(width / ratio);
            items.width(width).height(height).show();
            target.width(items.length * (width + margin)).height(height);
        } else {
            items.width(width).show();
            target.width(items.length * (width + margin));
        }

        target.stop().css({
            "margin-left" : - _this.cur * (width + margin)
        }, 200);
    }
}

var imgReady = (function () {
    var list = [], intervalId = null,

    // 用来执行队列
        tick = function () {
            var i = 0;
            for (; i < list.length; i++) {
                list[i].end ? list.splice(i--, 1) : list[i]();
            };
            !list.length && stop();
        },

    // 停止所有定时器队列
        stop = function () {
            clearInterval(intervalId);
            intervalId = null;
        };

    return function (url, ready, load, error) {
        var onready, width, height, newWidth, newHeight,
            img = new Image();

        img.src = url;

        // 如果图片被缓存，则直接返回缓存数据
        if (img.complete) {
            ready.call(img);
            load && load.call(img);
            return;
        };

        width = img.width;
        height = img.height;

        // 加载错误后的事件
        img.onerror = function () {
            error && error.call(img);
            onready.end = true;
            img = img.onload = img.onerror = null;
        };

        // 图片尺寸就绪
        onready = function () {
            newWidth = img.width;
            newHeight = img.height;
            if (newWidth !== width || newHeight !== height ||
                // 如果图片已经在其他地方加载可使用面积检测
                newWidth * newHeight > 1024
                ) {
                ready.call(img);
                onready.end = true;
            };
        };
        onready();

        // 完全加载完毕的事件
        img.onload = function () {
            // onload在定时器时间差范围内可能比onready快
            // 这里进行检查并保证onready优先执行
            !onready.end && onready();

            load && load.call(img);

            // IE gif动画会循环执行onload，置空onload即可
            img = img.onload = img.onerror = null;
        };

        // 加入队列中定期执行
        if (!onready.end) {
            list.push(onready);
            // 无论何时只允许出现一个定时器，减少浏览器性能损耗
            if (intervalId === null) intervalId = setInterval(tick, 40);
        };
    };
})();

Pages.indexPage.url = "/mobile/interface-home-lastId-@{lastId}.html";

Pages.specialPage.url = "/mobile/interface-special.html";
Pages.specialDetailPage.url = "/mobile/interface-special-id-@{id}.html";

Pages.rankPage.url = "/mobile/interface-rank.html";
Pages.rankPage.tabs[0].url = "/mobile/interface-rank-t-month-lastId-@{lastId}.html";
Pages.rankPage.tabs[1].url = "/mobile/interface-rank-t-all-lastId-@{lastId}.html";

Pages.categoryPage.url = "/mobile/interface-category.html";
Pages.searchPage.url = "/mobile/interface-search.html";
Pages.searchResultPage.url = "/mobile/interface-search.html?key=@{key}&lastId=@{lastId}";
Pages.gameListPage.url = "/mobile/interface-gameList-id-@{id}-lastId-@{lastId}.html";
Pages.detailPage.url = "/mobile/interface-detail-id-@{id}.html";
Pages.strategyDetailPage.url = "/mobile/interface-strategyDetail-id-@{id}";